﻿#pragma once

// CAttachDownloadList

#define DEF_ATTACH_LIST_BG_COLOR				Color(255, 255, 255, 255)
#define DEF_ATTACH_LIST_ITEM_BG_COLOR			Color(255, 255, 255, 255)
#define DEF_ATTACH_LIST_ITEMSEL_BG_COLOR		Color(255, 255, 255, 255)
#define DEF_ATTACH_LIST_LINE_COLOR				Color(255, 225, 229, 234)

#define DEF_ATTACH_LIST_FONT_NAME				(L"나눔고딕")
#define DEF_ATTACH_LIST_FONT_HEIGHT				(9.5)
#define DEF_ATTACH_LIST_FONT_COLOR				Color(255, 102, 102, 102)
#define DEF_ATTACH_LIST_FONT_STYLE				(FontStyleRegular)

#define DEF_LIST_NAME_LEFT_POS_X				(5)

#define DEF_LIST_STATUS_TXT_COMPLETE			_T("complete")

class CAttachDownloadList : public CListCtrl
{
	DECLARE_DYNAMIC(CAttachDownloadList)

public:
	CAttachDownloadList();
	virtual ~CAttachDownloadList();

public:
	typedef enum _attach_status
	{
		EATTACH_READY = 0,
		EATTACH_DOWNLOADING,
		EATTACH_COMPLETE,
		EATTACH_FAIL,
		EATTACH_CANCEL
	} EATTACH_STATUS;

	typedef struct _attach_list_item
	{
		CString			strName;
		CSize			szName;
		CString			strSize;
		ULONGLONG		dwTotalSize;
		ULONGLONG		dwCurDownloadSize;
		_attach_status	eStatus;

		_attach_list_item()
		{
			strName = _T("");
			szName.SetSize(0, 0);
			strSize = _T("");
			dwTotalSize = 0;
			dwCurDownloadSize = 0;
			eStatus = EATTACH_READY;
		}
	} ATTACH_LIST_ITEM, *PATTACH_LIST_ITEM;

	Image*				m_pImgBG;
	Image*				m_pImgFile;
	Image*				m_pImgProgressBG;
	Image*				m_pImgProgressFG;

	Color				m_crBG;
	Color				m_crItemBG;
	Color				m_crItemSelBG;
	Color				m_crOutline;

	void				SetImgBGPath(CString strFileName);
	void				SetImgFilePath(CString strFileName);
	void				SetImgProgressPath(CString strFileNameFG, CString strFileNameBG);

	WCHAR				m_wszFontName[64];
	REAL				m_nFontHeight;
	FontStyle			m_fontStyle;
	Color				m_crText;

	void				SetFontConfig(WCHAR* wszFontName, REAL nFontHeight, FontStyle style, Color crText);

	void				ClearAttachItem();
	_attach_list_item*	AllocAttachItem(CString strName, ULONGLONG dwSize, int nStatus);
	void				AddAttachItem(CString strName, ULONGLONG dwSize, int nStatus = EATTACH_READY);
	void				UpdateAttachItemSize(int nItem, ULONGLONG dwSize);
	void				UpdateAttachItemStatus(int nItem, int nStatus);
	void				UpdateAttachItemFilename(int nItem, LPCTSTR strRename);
	void				UpdateSubItem(int nItem, int nSubItem);

protected:
	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnCustomDraw(NMHDR* pNMHDR, LRESULT* pResult);
	afx_msg void OnDestroy();
};
